/* Problem URL: https://codeforces.com/gym/104736/problem/J */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vvi graph(n);

    rep(i, n - 1) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    vi ans(n);
    int prev = n - 1;

    if (n > 1) {
        n = 1 << (32 - __builtin_clz(n - 1));
    }

    int inf = INT32_MAX >> 1;
    vi seg(n * 2, inf);

    auto update = [&](int i, int v) {
        seg[i + n] = v;
        for (int j = (i + n) / 2; j > 0; j /= 2) {
            seg[j] = min(seg[j * 2], seg[j * 2 + 1]);
        }
    };

    function<int(int, int, int, int, int)> search = [&](int i, int l, int r, int tl, int tr) {
        if (l > tr || r < tl || seg[i] == inf) {
            return -1;
        }

        if (l == r) {
            return i - n;
        }

        if (l >= tl && r <= tr) {
            int mid = (l + r) / 2;
            if (seg[i * 2] <= seg[i * 2 + 1]) {
                return search(i * 2, l, mid, tl, tr);
            }
            return search(i * 2 + 1, mid + 1, r, tl, tr);
        }

        int mid = (l + r) / 2;
        int ans1 = search(i * 2, l, mid, tl, tr);
        int ans2 = search(i * 2 + 1, mid + 1, r, tl, tr);

        if (ans2 == -1 || seg[ans1 + n] < seg[ans2 + n] || (seg[ans1 + n] == seg[ans2 + n] && ans1 < ans2)) {
            return ans1;
        }
        return ans2;
    };

    function<void(int, int, int)> dfs = [&](int i, int p, int d) {
        update(i, d);

        ans[i] = search(1, 0, n - 1, i, n - 1) + 1;

        for (auto j : graph[i]) {
            if (j == p) {
                continue;
            }

            dfs(j, i, d - 1);
        }

        update(i, inf);
    };

    dfs(prev, -1, inf - 1);

    cout << ans;
}
